Subject: [xrblock] I-D Action: draft-ietf-xrblock-rtcp-xr-discard-02.txt

From: [email-masked]
Date: Tue, 17 Apr 2012 21:59:47 -0700

A New Internet-Draft is available from the on-line Internet-Drafts directories. This draft is a work item of the Metric Blocks for use with RTCP's Extended Report Framework Working Group of the IETF.

	Title           : RTCP XR Report Block for Discard metric Reporting
	Author(s)       : Geoff Hunt
                          Alan Clark
                          Glen Zorn
                          Qin Wu
	Filename        : draft-ietf-xrblock-rtcp-xr-discard-02.txt
	Pages           : 13
	Date            : 2012-04-17

   This document defines an RTCP XR Report Block that allows the
   reporting of a simple discard count metric for use in a range of RTP
   applications.

A URL for this Internet-Draft is:
http://www.ietf.org/internet-drafts/draft-ietf-xrblock-rtcp-xr-discard-02.txt

Internet-Drafts are also available by anonymous FTP at:
ftp://ftp.ietf.org/internet-drafts/

This Internet-Draft can be retrieved at:
ftp://ftp.ietf.org/internet-drafts/draft-ietf-xrblock-rtcp-xr-discard-02.txt

---

From: Qin Wu <[email-masked]>
Date: Wed, 18 Apr 2012 13:02:51 +0800

> http://www.ietf.org/internet-drafts/draft-ietf-xrblock-rtcp-xr-discard-02.txt

[Qin]: Here is the update to Discard draft based on our discussion and proposal in the Paris meeting.
The only change is to use 2bits in the block header to identify each discard type.

---

From: Varun Singh <[email-masked]>
Date: Wed, 18 Apr 2012 11:58:10 +0300

Hi Qin,

Instead of defining DT=11:  "packets are discarded due to both early
arrival and late arrival."

It could be defined as "total discards in an interval" (not
necessarily due to late or early arrival). By generalizing DT=11, the
codepoint can be used to report other reasons of packet discard in an
interval e.g., due to duplication or redundancy.

Cheers,
Varun

On Wed, Apr 18, 2012 at 08:02, Qin Wu <[email-masked]> wrote:
> _______________________________________________
> xrblock mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/xrblock

-- 
http://www.netlab.tkk.fi/~varun/

---

From: Qin Wu <[email-masked]>
Date: Wed, 18 Apr 2012 19:10:08 +0800

Hi, Varun:
Your proposed change looks good to me since section 1.1 of Discard draft says:
"
    The new block type
   supports the reporting of the number of packets which are received
   correctly but are never played out, typically because they arrive too
   late to be played out (buffer underflow) or too early (buffer
   overflow).  The metric is applicable both to systems which use packet
   loss repair techniques (such as forward error correction [RFC5109] or
   retransmission [RFC4588]) and to those which do not.

"
So the typical reason is due to late arrival or early arrival. However it doesn't
preclude other reasons. Also the last sentence indicates packet loss repair techniques
may be another potential reason for discard,i.e., redundancy or duplication due to
multiple retransmission. So I agree with your proposal.

Regards!
-Qin
----- Original Message ----- 
From: "Varun Singh" <[email-masked]>
To: "Qin Wu" <[email-masked]>
Cc: <[email-masked]>
Sent: Wednesday, April 18, 2012 4:58 PM
Subject: Re: [xrblock] I-D Action: draft-ietf-xrblock-rtcp-xr-discard-02.txt

Hi Qin,

Cheers,
Varun

---

From: Varun Singh <[email-masked]>
Date: Wed, 18 Apr 2012 14:50:02 +0300

Hi Qin,

> multiple retransmission. So I agree with your proposal.

Apologies, if this adds confusion.

I just realized that it was Charles or someone else who brought up the
original proposal to combine the early and late discards. My earlier
proposal may not cover that specific use-case because an endpoint
would report all discards instead of just reporting early and late
discards. Another alternative to preserve that use-case would be to
have the following code points:

DT=

00 for total discards due to miscellaneous reasons
01 for early.
10 for late.
11 for early and late.

In this case you would have to add DT=00 for total discards in an
interval (I) due to miscellaneous reasons (e.g., redundancy,
duplication etc).

Cheers,
Varun

---

From: Qin Wu <[email-masked]>
Date: Thu, 19 Apr 2012 09:03:07 +0800

Hi, Varun and Charles:
----- Original Message ----- 
>Sent: Wednesday, April 18, 2012 7:50 PM

>original proposal to combine the early and late discards. 

[Qin]: I remember it was Charles.

>My earlier proposal may not cover that specific use-case because an endpoint
>discards.

[Qin]: I see.

> Another alternative to preserve that use-case would be to

>interval (I) due to miscellaneous reasons (e.g., redundancy,

[Qin]: In that case, in some circumstances when there is no duplication and redundancy, the total packets discarded due to miscellaneous reasons is
the same as number of packets dicarded due to early and late.
But this proposal still looks okay to me since we have enough bits to identify each discard type.:-)

Charles: What do you think of it?

>>>> A New Internet-Draft is available from the on-line Internet-Drafts directories. This draft is a work item of the Metric Blocks for use with RTCP's Extended Report Framework Working Group of the >IETF.
>>>>

---

From: Varun Singh <[email-masked]>
Date: Thu, 19 Apr 2012 09:43:30 +0300

Hi Qin,

> Hi, Varun and Charles:
 [snip!]

> the same as number of packets dicarded due to early and late.

Probably the meaning needs to be clarified but miscellaneous reasons
should exclude packets discarded due to arrival time (early, late or
both).

Cheers,
Varun

---

From: Qin Wu <[email-masked]>
Date: Thu, 19 Apr 2012 15:47:53 +0800

Hi, Varun:
----- Original Message ----- 
From: "Varun Singh" <[email-masked]>
To: "Qin Wu" <[email-masked]>
Cc: <[email-masked]>; "Charles Eckel (eckelcu)" <[email-masked]>
Sent: Thursday, April 19, 2012 2:43 PM
Subject: Re: [xrblock] I-D Action: draft-ietf-xrblock-rtcp-xr-discard-02.txt

> should exclude packets discarded due to arrival time (early, late or

[Qin]: I thought miscellaneous reasons not only include both early and late arrival,
but also include other reason like redundancy.
You explaination to "miscellaneous  reasons" is ambiguous to me, how do people
figure out miscellaneous reasons should exclude both early and late arrival?

---

From: Varun Singh <[email-masked]>
Date: Thu, 19 Apr 2012 13:07:44 +0300

> figure out miscellaneous reasons should exclude both early and late arrival?

DT=
00: to report other reasons for discard than early, or late arrival of
packets, e.g., duplicate, redundant packets
01: to report packet discarded due to early arrival
10: to report packet discarded due to late arrival
11: to report packet discarded due to both early and late arrival

note: to calculate total discards, the endpoint may have to send both
DT= 00 and DT=11.

comparing to the first proposal,
DT=
01: to report packet discarded due to early arrival
10: to report packet discarded due to late arrival
11: to report total number of discarded packets in the interval (I)

In this case the total contains all discarded packets.

---

From: "Charles Eckel (eckelcu)" <[email-masked]>
Date: Thu, 19 Apr 2012 17:31:32 -0700

I am fine either way, so long as we document it clearly:

Option 1, a discard may be counted in more than one category
00 for total discards for any reason, including late, early, both, misc.
01 for early
10 for late 
11 for early and late

Option 2, a discard may be counted in no more than one category

00 for misc. discards other than late, early, or both
01 for early only
10 for late only
11 for early and late

Cheers,
Charles

> -----Original Message-----
> From: Varun Singh [mailto:[email-masked]]
> Sent: Thursday, April 19, 2012 3:08 AM
> To: Qin Wu
> Cc: [email-masked]; Charles Eckel (eckelcu)
> >>> [Qin]: In that case, in some circumstances when there is no
> duplication and redundancy, the total packets discarded due to
> miscellaneous reasons is

---

From: Qin Wu <[email-masked]>
Date: Fri, 20 Apr 2012 09:05:41 +0800

Hi, Varun:
From your rewording, the second proposal is more reasonable to me.:-)
I like to go with this proposal if I hear no objection.

Regards!
-Qin
----- Original Message ----- 
From: "Varun Singh" <[email-masked]>
To: "Qin Wu" <[email-masked]>
Cc: <[email-masked]>; "Charles Eckel (eckelcu)" <[email-masked]>
Sent: Thursday, April 19, 2012 6:07 PM
Subject: Re: [xrblock] I-D Action: draft-ietf-xrblock-rtcp-xr-discard-02.txt

DT=

---

From: Kevin Gross <[email-masked]>
Date: Fri, 20 Apr 2012 09:15:22 -0600

I have not reviewed this draft but I have two questions about this
discussion:

   1. What's the justification for inclusion of 11 as a sum of 01 and 10?
   Can't monitoring devices do the arithmetic?
   2. What are examples of other reasons for discarding packets that would
   fall into the 00 category?

Kevin Gross

On Thu, Apr 19, 2012 at 7:05 PM, Qin Wu <[email-masked]> wrote:

> Subject: Re: [xrblock] I-D Action:
> draft-ietf-xrblock-rtcp-xr-discard-02.txt
>
>
> > Subject: Re: [xrblock] I-D Action:
> draft-ietf-xrblock-rtcp-xr-discard-02.txt
> >
> >
> >> Hi Qin,
> >>

---

From: Qin Wu <[email-masked]>
Date: Sat, 21 Apr 2012 10:02:41 +0800

Hi,
  ----- Original Message ----- 
  From: Kevin Gross 
  To: Qin Wu 
  Cc: Varun Singh ; [email-masked] 
  Sent: Friday, April 20, 2012 11:15 PM
  Subject: Re: [xrblock] I-D Action: draft-ietf-xrblock-rtcp-xr-discard-02.txt

   I have not reviewed this draft but I have two questions about this discussion:
    1.. What's the justification for inclusion of 11 as a sum of 01 and 10? Can't monitoring devices do the arithmetic?
[Qin]: 
The initial version of discard draft is only used to report the total number of packet discarded. However someone in the IETF82 meeting thought it 
will be more useful to distinguish discard due to early arrival from late arrival. That's why reporting discard due to early arrvial or late arrival is 
introduced in the later version. In order to not break the existing use that needs to report the total number of packet discareded, it is better not 
to remove the total number packet discarded reporting.

Seconly, in some case, we need to know the total number of packets discarded due to buffer overflow and underflow in one interval and
are not interested in packet discarded due to only early arrival or only late arrival. In such case, it more make sense to report the total
number of packet discarded due to both early and late arrival within implementation specific time window rather than report them separately and 
do the arithmetic.

  2. What are examples of other reasons for discarding packets that would fall into the 00 category?
[Qin]: I am not aware of that. Kevin, would you like to clarify this a little bit?

  Kevin Gross

    Hi, Varun:

    Regards!
    -Qin

    ----- Original Message -----
    From: "Varun Singh" <[email-masked]>
    To: "Qin Wu" <[email-masked]>
    Cc: <[email-masked]>; "Charles Eckel (eckelcu)" <[email-masked]>

    DT=